import lolex from 'lolex';
import test from 'tape';

import messageHide from './messageHide';
import messageShow from './messageShow';

import createStore from '../../../test-utils/createStore';


test('can hide message', (t) => {
    const clock = lolex.install();

    const store = createStore();

    store.dispatch(messageShow('billogram'));
    const entry = store.getState().messages.entries[0];

    store.dispatch(messageHide({ text: 'billogram', timeoutId: entry.timeoutId, timestamp: entry.timestamp }));
    const state = store.getState().messages;

    t.is(state.entries.length, 0, 'should have no entries');

    clock.uninstall();

    t.end();
});
