import messageHide from './messageHide';


export const type = '@@billogram-foundation/MESSAGE.SHOW';

export const show = ({ text, timeoutId, timestamp, ui }) => {
    return {
        type,
        payload: {
            text,
            timeoutId,
            timestamp,
            ui
        }
    };
};

export default (text, { ui } = {}) => {
    return (dispatch) => {
        const timestamp = +new Date();

        let timeoutId;
        timeoutId = setTimeout(() => dispatch(messageHide({ timeoutId, timestamp })), 5000);

        dispatch(show({ text, timeoutId, timestamp, ui }));
    };
};

export const reducer = {
    [type]: (state, action) => {
        const { text, timeoutId, timestamp, ui } = action.payload;
        return {
            ...state,
            entries: [...state.entries, {
                text,
                timeoutId,
                timestamp,
                ui
            }]
        };
    }
};
