import test from 'tape';

import textboxTextState from './textboxTextState';


test('should have sensible defaults', (t) => {
    const state = textboxTextState();
    t.same(state, { focus: false, rawValue: '', value: '' });
    t.end();
});


test('should set rawValue when setting value', (t) => {
    const state = textboxTextState({ value: 'a' });
    t.same(state, { focus: false, rawValue: 'a', value: 'a' });
    t.end();
});

test('should convert numeric value to string', (t) => {
    const state = textboxTextState({ value: 1 });
    t.same(state, { focus: false, rawValue: '1', value: '1' });
    t.end();
});
