import { isError } from 'flux-standard-action';
import Immutable from 'seamless-immutable';


const isFunction = (obj) => typeof obj === 'function';

export default (type, reducers) => {
    return (state, action) => {
        if (action.type !== type) {
            return state;
        }

        const handlerKey = isError(action)
            ? 'throw'
            : 'next';

        if (isFunction(reducers)) {
            reducers.next = reducers;
        }

        const reducer = reducers[handlerKey];

        return isFunction(reducer)
            ? Immutable(reducer(state, action))
            : state;
    };
};
